// ========================================================================
// Copyright 2007 Mort Bay Consulting Pty. Ltd.
// ------------------------------------------------------------------------
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at 
// http://www.apache.org/licenses/LICENSE-2.0
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//========================================================================

package org.mortbay.cometd;

import java.io.IOException;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletResponse;

import org.mortbay.util.ajax.JSON;

public interface Transport 
{
    public void setResponse(HttpServletResponse response) throws IOException;

    public void send(JSON.Literal reply) throws IOException;
    public void send(Map<String, Object> reply) throws IOException;
    public void send(List<Map<String, Object>> replies) throws IOException;
    public void complete() throws IOException;
    
    public boolean isPolling();
    public void setPolling(boolean polling);
    public boolean keepAlive() throws IOException;
    
    public void setJSONCommented(boolean commented);
    public boolean isJSONCommented();
    
    public boolean alwaysResumePoll();
    
}